/* -*- mode: c++; c-basic-offset: 2; -*- */
%module globus_ftp_client
%{
#include "globus_ftp_client.h"
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS

%exception globus_ftp_client_restart_marker_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_restart_marker_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_restart_marker_copy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_restart_marker_insert_range GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_restart_marker_set_offset GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_restart_marker_set_ascii_offset GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_restart_marker_get_total GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_restart_marker_to_string GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_restart_marker_from_string GLOBUS_EXCEPTION_RESULT_T;

%exception globus_ftp_client_handle_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handle_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handle_cache_url_state GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handle_flush_url_state GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handle_set_user_pointer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handle_get_user_pointer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handle_add_plugin GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handle_remove_plugin GLOBUS_EXCEPTION_RESULT_T;

%exception globus_ftp_client_handleattr_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_copy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_add_cached_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_remove_cached_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_set_cache_all GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_get_cache_all GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_set_rfc1738_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_get_rfc1738_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_set_netlogger GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_set_netlogger_ftp_io GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_remove_plugin GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_handleattr_add_plugin GLOBUS_EXCEPTION_RESULT_T;

%exception globus_ftp_client_chmod GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_cksm GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_delete GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_mkdir GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_rmdir GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_list GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_verbose_list GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_machine_list GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_mlst GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_move GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_get GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_put GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_third_party_transfer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_partial_get GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_partial_put GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_partial_third_party_transfer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_extended_get GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_extended_put GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_extended_third_party_transfer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_abort GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_modification_time GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_size GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_exists GLOBUS_EXCEPTION_RESULT_T;

%exception globus_ftp_client_operationattr_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_parallelism GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_parallelism GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_striped GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_striped GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_layout GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_layout GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_tcp_buffer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_tcp_buffer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_list_uses_data_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_list_uses_data_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_dcau GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_dcau GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_data_protection GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_data_protection GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_control_protection GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_control_protection GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_resume_third_party_transfer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_resume_third_party_transfer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_authorization GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_authorization GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_append GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_append GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_set_read_all GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_get_read_all GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_operationattr_copy GLOBUS_EXCEPTION_RESULT_T;

%exception globus_ftp_client_register_read GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_client_register_write GLOBUS_EXCEPTION_RESULT_T;

#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */

%include "cpointer.i" 

/* for globus_off_t */
/* %import "globus_config.h" */

/* for globus_size_t */
%import "globus_common_include.h"

%import "globus_ftp_control.h"

%apply globus_result_t		{ globus_result_t };

/*
 * globus_ftp_client_restart_marker_to_string()
 * globus_ftp_client_operationattr_get_authorization()
 */
%apply char			**OUTPUT { char ** };

/*
 * globus_ftp_client_handle_set_user_pointer()
 */
%apply void			**OUTPUT { void ** };

/*
 * globus_ftp_client_restart_marker_get_total()
 */
%apply globus_off_t 		* OUTPUT { globus_off_t * };


/*
 * globus_ftp_client_modification_time()
 */
%apply globus_abstime_t		* OUTPUT { globus_abstime_t * };

/*
 * globus_ftp_client_handleattr_get_cache_all()
 * globus_ftp_client_operationattr_get_striped()
 * globus_ftp_client_operationattr_get_append()
 */  	 
%apply globus_bool_t		* OUTPUT { globus_bool_t * };

/*
 * globus_ftp_client_operationattr_get_type()
 */
%apply globus_ftp_control_type_t	*OUTPUT { globus_ftp_control_type_t * };

/*
 * globus_ftp_client_operationattr_get_mode()
 */
%apply globus_ftp_control_mode_t	*OUTPUT { globus_ftp_control_mode_t * };
/*
 * globus_ftp_client_operationattr_get_data_protection()
 * globus_ftp_client_operationattr_get_control_protection() 
 */
%apply globus_ftp_control_protection_t 	*OUTPUT { globus_ftp_control_protection_t  * };


/* The actual file to wrap */
%include "globus_ftp_client.h"

/* There are no allocator functions provided for these types, so we
   use cpointer to provide it */

%pointer_functions(globus_ftp_client_handle_t,
                   p_globus_ftp_client_handle_t);

%pointer_functions(globus_ftp_client_plugin_t,
                   p_globus_ftp_client_plugin_t);

%pointer_functions(globus_ftp_client_handleattr_t,
                   p_globus_ftp_client_handleattr_t);

%pointer_functions(globus_ftp_client_operationattr_t,
                   p_globus_ftp_client_operationattr_t);

/* temp fix for globus ftp put operation */

%include "cdata.i"
