/* -*- mode: c++; c-basic-offset: 2; -*- */
%module globus_ftp_control
%{
#include "globus_ftp_control.h"

%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS

/* %exception globus_ftp_control_layout_register_func GLOBUS_EXCEPTION_RESULT_T; */
/* %exception globus_X_ftp_control_local_layout GLOBUS_EXCEPTION_RESULT_T; */
%exception globus_ftp_control_local_layout GLOBUS_EXCEPTION_RESULT_T;
/* %exception globus_ftp_control_set_netlogger GLOBUS_EXCEPTION_RESULT_T; */
%exception globus_ftp_control_data_set_interface GLOBUS_EXCEPTION_RESULT_T;

/* blocked functions */
/* %exception globus_ftp_control_layout_blocked_verify GLOBUS_EXCEPTION_RESULT_T; */
/* %exception globus_ftp_control_layout_blocked GLOBUS_EXCEPTION_RESULT_T; */

/* partitioned functions */
/* %exception globus_ftp_control_layout_partitioned_verify GLOBUS_EXCEPTION_RESULT_T; */
/* %exception globus_ftp_control_layout_partitioned GLOBUS_EXCEPTION_RESULT_T; */

/* data registration functions */
/* %exception globus_ftp_control_create_data_info GLOBUS_EXCEPTION_RESULT_T; */
%exception globus_ftp_control_release_data_info GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_write_stripe GLOBUS_EXCEPTION_RESULT_T;
%exception globus_X_ftp_control_data_write_stripe GLOBUS_EXCEPTION_RESULT_T;

/* globus_ftp_control_client.c */
%exception globus_ftp_control_auth_info_init GLOBUS_EXCEPTION_RESULT_T;
/*%exception globus_ftp_control_auth_info_compare GLOBUS_EXCEPTION_RESULT_T;*/
/*%exception globus_ftp_control_handle_init GLOBUS_EXCEPTION_RESULT_T;*/
%exception globus_ftp_control_handle_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_server_handle_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_server_handle_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_response_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_response_copy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_connect GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_authenticate GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_abort GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_quit GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_force_close GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_send_command GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_pbsz GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_get_pbsz GLOBUS_EXCEPTION_RESULT_T;

/* globus_ftp_control_server.c */
%exception globus_ftp_control_server_listen GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_server_stop GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_server_accept GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_server_authenticate GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_read_commands GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_send_response GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_close GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_data_close GLOBUS_EXCEPTION_RESULT_T;

/* command object functions */
%exception globus_ftp_control_command_copy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_command_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_command_destroy GLOBUS_EXCEPTION_RESULT_T;

/* globus_ftp_control_data.c */
%exception globus_i_ftp_control_data_cc_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_i_ftp_control_data_cc_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_force_close GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_send_eof GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_send_eof GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_get_stripe_count GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_connect_read GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_connect_write GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_add_channels GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_remove_channels GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_query_channels GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_get_total_data_channels GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_get_remote_hosts GLOBUS_EXCEPTION_RESULT_T;


%exception globus_ftp_control_get_parallelism GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_parallelism GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_pasv GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_spas GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_port GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_spor GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_get_spor GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_tcp_buffer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_get_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_get_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_dcau GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_get_dcau GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_prot GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_get_prot GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_local_stru GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_write GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_read GLOBUS_EXCEPTION_RESULT_T;
%exception globus_ftp_control_data_read_all GLOBUS_EXCEPTION_RESULT_T;

/* internal function defintions */
%exception globus_i_ftp_parallelism_copy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_i_ftp_parallelism_get_size GLOBUS_EXCEPTION_RESULT_T;
%exception globus_i_ftp_parallelism_get_min_size GLOBUS_EXCEPTION_RESULT_T;
%exception globus_i_ftp_parallelism_get_max_size GLOBUS_EXCEPTION_RESULT_T;
%exception globus_i_ftp_control_client_get_connection_info GLOBUS_EXCEPTION_RESULT_T;

#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */

/*
 * These two are declared but not defined, causing missing
 * symbols at symbol resolution/dynamic link time
 */
%ignore globus_ftp_control_close;
%ignore globus_ftp_data_close;

/* net logger stuff */
%ignore globus_ftp_control_set_netlogger;

/* internal functions */
%ignore globus_i_ftp_queue_size;
%ignore globus_i_ftp_control_data_cc_init;
%ignore globus_i_ftp_control_data_cc_destroy;

/* layout functions */
%ignore globus_ftp_control_layout_register_func;
%ignore globus_X_ftp_control_local_layout;

/* blocked functions */
%ignore globus_ftp_control_layout_blocked_verify;
%ignore globus_ftp_control_layout_blocked_user_arg_create;
%ignore globus_ftp_control_layout_blocked_user_arg_destroy;
%ignore globus_ftp_control_layout_blocked;

/* partitioned functions */
%ignore globus_ftp_control_layout_partitioned_verify;
%ignore globus_ftp_control_layout_partitioned_user_arg_create;
%ignore globus_ftp_control_layout_partitioned_user_arg_destroy;
%ignore globus_ftp_control_layout_partitioned;

/* data registration functions */
/* %ignore globus_ftp_control_create_data_info; */
/* %ignore globus_ftp_control_release_data_info; */
/* %ignore globus_ftp_control_data_write_stripe; */
/* %ignore globus_X_ftp_control_data_write_stripe; */

/* need this get type info for globus_size_t */
%include "globus_common_include.h"

%import "gssapi.h"

%apply char			**OUTPUT { char ** };

%apply unsigned long		*OUTPUT { unsigned long * };

%apply int			*OUTPUT { unsigned int * };

%apply int			*OUTPUT { int * };

%apply unsigned short		*OUTPUT { unsigned short * };

%apply globus_ftp_control_type_t	*OUTPUT { globus_ftp_control_type_t * };

%apply globus_ftp_control_mode_t	*OUTPUT { globus_ftp_control_mode_t * };

%apply globus_ftp_control_protection_t 	*OUTPUT { globus_ftp_control_protection_t  * };

%include "globus_ftp_control.h"
