/* -*- mode: c++; c-basic-offset: 2; -*- */
%module globus_gass_cache
%{
#include "globus_gass_cache.h"
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS
%exception GLOBUS_EXCEPTION( gass_cache )
#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */
  
%{
  /*
   * If exception handling is being used, make sure it is disabled for the
   *   following functions as they do not return status
   */
%}

%exception globus_gass_cache_error_string;


%include "cpointer.i" 

/* for globus_off_t */
/* %import "globus_config.h"  */

/* for globus_size_t */
%import "globus_common_include.h"

//%import "globus_common.h"

%apply char			**OUTPUT { char ** };

%apply int	 		* OUTPUT { int * };

%apply unsigned long		* OUTPUT { unsigned long * };

%apply globus_bool_t		* OUTPUT { globus_bool_t * };

/*
 * The actual file to wrap
 */
%include "globus_gass_cache.h"
