/* -*- mode: c++; c-basic-offset: 2; -*- */
%module globus_gram_client

%{
#include "stdio.h"
#include "globus_common.h"
#include "globus_common_include.h"  
#include "globus_gram_client.h"
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS
%exception GLOBUS_EXCEPTION( gram_client )
#endif

%{
  /*
   * If exception handling is being used, make sure it is disabled for the
   *   following functions as they do not return status
   */
%}
%exception globus_gram_client_version;
%exception globus_gram_client_debug;
%exception globus_gram_client_error_string;

%import "gssapi.h"
%import "globus_gram_protocol_constants.h"

%apply char 			**OUTPUT { char ** };

%apply int			*OUTPUT { int * };

%include "globus_gram_client.h"

#if 0
#if !defined( SWIGTCL )

%include "cpointer.i" 

%pointer_functions(globus_gram_client_attr_t, p_globus_gram_client_attr_t);

#endif
#endif
