/* -*- mode: c++; c-basic-offset: 2; -*- */
%include "tcl-typemaps.i"
%include "swig/globus_gram_client-4.0.i"

/*
 * ----------------------------------------------------------------------
 * Callback support
 * ----------------------------------------------------------------------
 */

%{
#include "../../config.h"

#include <stdio.h>
#include <tcl.h>

#include "tcl-callback.h"

  static void
    TclGramCallback( void* user_callback_arg,
		     char* job_contact,
		     int state,
		     int errorcode )
    {
      CallCallback( (callbackStruct*)user_callback_arg,
		    "%s %d %d",
		    job_contact, state, errorcode );
    }

  static void
    TclGramNonblockingCallback( void * user_callback_arg,
				globus_gram_protocol_error_t operation_failure_code,
				const char *job_contact,
				globus_gram_protocol_job_state_t job_state,
				globus_gram_protocol_error_t job_failure_code )
    {
      CallCallback( (callbackStruct*)user_callback_arg,
		    "%s %d %d",
		    job_contact, job_state, job_failure_code );
    }
%}
