/* -*- mode: c++; c-basic-offset: 2; -*- */

%module globus_gsi_cert_utils
%{
#include "openssl/x509.h"
#include "openssl/asn1.h"  
#include "openssl/safestack.h"
#include "globus_gsi_cert_utils.h"
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS

%exception globus_gsi_cert_utils_make_time GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cert_utils_get_base_name GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cert_utils_get_cert_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cert_utils_get_x509_name GLOBUS_EXCEPTION_RESULT_T;
%exception globus_i_gsi_cert_utils_dn_cmp GLOBUS_EXCEPTION_RESULT_T;

#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */

#include "openssl/x509.h"
#include "openssl/asn1.h"
%include "openssl/safestack.h"

%import "globus_common_include.h"

%import "globus_gsi_cert_utils_constants.h"

%apply globus_gsi_cert_utils_cert_type_t *OUTPUT { globus_gsi_cert_utils_cert_type_t * };

%apply time_t		*OUTPUT { time_t * };

%include "globus_gsi_cert_utils.h"
