/* -*- mode: c++; c-basic-offset: 2; -*- */

%module globus_gsi_system_config
%{
#include "globus_gsi_system_config.h"
#include "globus_gsi_system_config_constants.h"
%}


/* %include "cpointer.i" */
/* %pointer_functions(globus_gsi_statcheck_t, globus_gsi_statcheck_t_p); */
/* %pointer_functions(int, int_p); */

%include "typemaps.i"
/* Some of these don't work :-( */
#ifdef 0
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_get_home_dir_unix */
%apply char **OUTPUT { char **home_dir };
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_get_cert_dir_unix */
%apply char **OUTPUT { char **cert_dir };
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_get_user_cert_filename_unix */
%apply char **OUTPUT { char **user_cert_filename, char **user_key_filename }; 
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_get_host_cert_filename_unix */
%apply char **OUTPUT { char **host_cert_filename, char **host_key_filename }; 
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_get_service_cert_filename_unix */
%apply char **OUTPUT { char **service_cert_filename, char **service_key_filename }; 
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_get_proxy_filename_unix */
%apply char **OUTPUT { char **proxy_filename };
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_get_signing_policy_filename_unix */
%apply char **OUTPUT { char **signing_policy_filename };
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_get_current_working_dir_unix */
%apply char **OUTPUT { char **working_dir };
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_split_dir_and_filename_unix */
%apply char **OUTPUT { char **dir_string, char **filename_string };
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_globus_gsi_sysconfig_get_user_id_string_unix */
%apply char **OUTPUT { char **user_id_string };
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_globus_gsi_sysconfig_get_username_unix */
%apply char **OUTPUT { char **username };
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_globus_gsi_sysconfig_get_proc_id_string_unix */
%apply char **OUTPUT { char **proc_id_string };
/* apply char ** OUTPUT typemap to globus_gsi_sysconfig_globus_gsi_sysconfig_get_gridmap_filename_unix */
%apply char **OUTPUT { char **filename };

#endif

%apply int *OUTPUT { int *is_superuser };

/* general typemap for output char ** arguments.  Above should have worked completely, but a few didn't */
%apply char **OUTPUT { char ** };

/* apply globus_gsi_statcheck_t * OUTPUT typemap to all functions that use it */
%apply globus_gsi_statcheck_t *OUTPUT { globus_gsi_statcheck_t * };

%include "globus_gsi_system_config.h"
%include "globus_gsi_system_config_constants.h"
