/* -*- mode: c++; c-basic-offset: 2; -*- */

%{
#include <tcl.h>
  
#include "common/sgdebug.h"  
#include "common/sginit.h"
  
#include "gt_xio_socket.h"

  %}

%exception {
  char* err;
  clear_exception( );
  $action
  if ( (err = check_exception( ) ) ) {
    croak(err);
  }
}

%init %{

  SGINIT_X509;
  
  char cmd_name[] = SWIG_prefix "gt_xio_socket";
  Tcl_CreateObjCommand( interp,
			cmd_name,
			gt_xio_socket,
			(ClientData)NULL,
			(Tcl_CmdDeleteProc*) NULL );
  %}

%wrapper %{
  static int
    gt_xio_socket( ClientData ClientData,
		   Tcl_Interp* Interp,
		   int ObjC,
		   Tcl_Obj* CONST objv[] )
    {
      static char function[] = "gt_xio_socket";
      SGDEBUG_LVL_FMT_1( 10, "Entering %s", function );
      
      return CreateGTXIOSocket( Interp, ObjC, objv );
      
    }
  %}





